package com.flyfish.framework.domain.authorized;

import com.flyfish.framework.context.UserContext;
import com.flyfish.framework.domain.base.AuditDomain;
import com.flyfish.framework.domain.po.User;
import lombok.Setter;
import org.apache.commons.lang3.StringUtils;

/**
 * 带鉴权的实体，主要以部门隔绝
 */
@Setter
public abstract class AuthorizedDomain extends AuditDomain {

    // 作用域id，一般是部门。用户存储时插入
    private String authorizeId;

    public String getAuthorizeId() {
        if (StringUtils.isNotBlank(authorizeId)) {
            return authorizeId;
        } else {
            return UserContext.sharedContext().map(UserContext::currentUser)
                    .map(User::getAuthority).orElse(null);
        }
    }
}
